package sim.portrayal;
import javax.swing.*;

/** An Inspector is a JPanel containing information about some object,
    and updates its displayed information when updateInspector() is called.
    In-between calls to updateInspector(), the Inspector should show the same
    information despite repeated repaints() etc.  
    Inspectors commonly also allow the user to change the information,
    but this is not required: they can be "read-only" if desired.
    */

public abstract class Inspector extends JPanel
    {
    public abstract void updateInspector();
    }